{-# LANGUAGE NamedFieldPuns #-}
{-# LANGUAGE RecordWildCards #-}

module Shift
  ( shiftMain,
    module X,
  )
where

import Control.Lens ((^.))
import Options.Applicative
import Shift.CLI as X
import Shift.Git as X
import Shift.Rendering as X
import Shift.Server (runServer)
import Shift.Types as X

-- | The main CLI entrypoint.
shiftMain :: IO ()
shiftMain = do
  currentOptions <- execParser opts

  case currentOptions ^. soCommand of
    GenerateCommand -> tempMain currentOptions
    ServeCommand {_scPort, ..} -> runServer _scPort currentOptions
  where
    opts =
      info
        (helper <*> shiftOptions)
        ( fullDesc
            <> progDesc "Execute the given COMMAND"
            <> header "shift - A change log generator"
        )
